/*
    ParaGUI - crossplatform widgetset
    Copyright (C) 2000,2001  Alexander Pipelka

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Alexander Pipelka
    pipelka@teleweb.at

    Last Update:      $Author: pipelka $
    Update Date:      $Date: 2001/05/30 20:07:40 $
    Source File:      $Source: /usr/local/CVSROOT/linux/paragui/include/Attic/pgrectlist.h,v $
    CVS/RCS Revision: $Revision: 1.1.2.8 $
    Status:           $State: Exp $
*/

#ifndef PG_RECTLIST_H
#define PG_RECTLIST_H

#include "pgrect.h"
#include <vector>

class DECLSPEC PG_RectList : public std::vector<PG_Widget*> {
public:

	virtual ~PG_RectList();

	PG_RectList Intersect(PG_Rect* rect, int first=0, int last=-1);
	PG_Widget* IsInside(PG_Point p);
	PG_RectList::iterator FindIndex(PG_Rect* rect);
	int FindIndexOf(PG_Rect* rect);
	bool Remove(PG_Rect* rect);
	void RestoreBackground();

	void Blit();
	void Update();
	void Blit(const PG_Rect& rect);

	bool BringToFront(PG_Widget* rect);
};

#endif	// PG_RECTLIST_H
